#ifndef _BINNING_H_
#define _BINNING_H_

#include <misc.h>

typedef struct index {
    int pos;
    int size;
    int start_used;
    int end_used;
    int child[2];
    Array rng; /* NULL => not loaded */
    int bin_id;
} bin_index_t;

typedef struct {
    int start;
    int end;
    int rec;
} range_t;

typedef struct {
    int nranges;
    range_t *ranges;
    int max_size;
} ranges_t;

typedef struct {
    void *data;
    ranges_t *rng;
    unsigned int glen; /* genome length */
} index_t;

ranges_t *create_ranges(void);
index_t *index_ranges(ranges_t *ranges, unsigned int glen);
void index_range_add(index_t *idx, range_t *items, int nitems);
void insert_base(index_t *idx, int pos);
void delete_base(index_t *idx, int pos);
int bin_save(index_t *idx, FILE *fp,
	     int (*obj_save)(FILE *fp, range_t *rng));

#endif /* _BINNING_H_ */
