#ifndef _TG_STRUCT_H_
#define _TG_STRUCT_H_

#include <g.h>

/* Suitable for solexa data, eg "slxa_0025_7_0021_3265" */
#define MAX_NAME_LEN 25
#define MAX_SEQ_LEN 40

/* Pileup sequence structure. Optimised for memory efficiency */
typedef struct {
    signed int  pos; /* left end, regardless of direction */
    signed char len; /* +ve or -ve indicates direction */
    char left, right; /* clip left/right coordinates */
    unsigned char name_len;
    char *name;
    char *seq;
    char *conf;
    char *data; /* on-disk format: name, seq, conf point into this */
} seq_t;

typedef struct {
    GCardinal pos;
    GCardinal len;
    GCardinal left;
    GCardinal right;
} GSeq_header;

typedef struct {
    GCardinal pos;
    GCardinal size;
    GCardinal start;
    GCardinal end;
    GCardinal child[2];
    GCardinal range;
    GCardinal id;
} GBin;

typedef struct {
    GCardinal start;
    GCardinal end;
    GCardinal object;
} GRange;

typedef struct {
    GCardinal length;
    GCardinal bin;
} GContig;

typedef struct {
    GDB *db;
    GClient client;
    GLock mode;
    GContig c;
} IO;

#endif /* _TG_STRUCT_H_ */
